
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
        <meta name="description" content="Official page of Anton Latukha">
      
      
      
        <link rel="canonical" href="https://blog.latukha.com/2017-05-04-Restore-of-deleted-LVM-%28Advanced%29/">
      
      
        <meta name="author" content="Anton Latukha">
      
      <link rel="shortcut icon" href="../assets/images/favicon-min.png">
      <meta name="generator" content="mkdocs-1.1.2, mkdocs-material-6.1.7">
    
    
      
        <title>Restore of deleted LVM (Advanced) - Latukha: Good day my friend!</title>
      
    
    
      <link rel="stylesheet" href="../assets/stylesheets/main.19753c6b.min.css">
      
        
        <link rel="stylesheet" href="../assets/stylesheets/palette.196e0c26.min.css">
        
          
          
          <meta name="theme-color" content="#7e56c2">
        
      
    
    
    
      
        
        <link href="https://fonts.gstatic.com" rel="preconnect" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Ubuntu:300,400,400i,700%7CHack&display=fallback">
        <style>body,input{font-family:"Ubuntu",-apple-system,BlinkMacSystemFont,Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Hack",SFMono-Regular,Consolas,Menlo,monospace}</style>
      
    
    
    
    
      
    
    
  </head>
  
  
    
    
    
    
    
    <body dir="ltr" data-md-color-scheme="" data-md-color-primary="deep-purple" data-md-color-accent="deep-purple">
      
  
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#restore-deleted-lvm-advanced" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
      

<header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid" aria-label="Header">
    <a href="https://blog.latukha.com" title="Latukha: Good day my friend!" class="md-header-nav__button md-logo" aria-label="Latukha: Good day my friend!">
      
  <img src="../assets/images/favicon-min.png" alt="logo">

    </a>
    <label class="md-header-nav__button md-icon" for="__drawer">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2z"/></svg>
    </label>
    <div class="md-header-nav__title" data-md-component="header-title">
      
        <div class="md-header-nav__ellipsis">
          <span class="md-header-nav__topic md-ellipsis">
            Latukha: Good day my friend!
          </span>
          <span class="md-header-nav__topic md-ellipsis">
            
              Restore of deleted LVM (Advanced)
            
          </span>
        </div>
      
    </div>
    
      <label class="md-header-nav__button md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0116 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 019.5 16 6.5 6.5 0 013 9.5 6.5 6.5 0 019.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"/></svg>
      </label>
      
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" data-md-state="active" required>
      <label class="md-search__icon md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0116 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 019.5 16 6.5 6.5 0 013 9.5 6.5 6.5 0 019.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"/></svg>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"/></svg>
      </label>
      <button type="reset" class="md-search__icon md-icon" aria-label="Clear" data-md-component="search-reset" tabindex="-1">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z"/></svg>
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header-nav__source">
        
<a href="https://github.com/Anton-Latukha/" title="Go to repository" class="md-source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path d="M439.55 236.05L244 40.45a28.87 28.87 0 00-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 01-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 000 40.81l195.61 195.6a28.86 28.86 0 0040.8 0l194.69-194.69a28.86 28.86 0 000-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Profile
  </div>
</a>
      </div>
    
  </nav>
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    

<nav class="md-nav md-nav--primary" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="https://blog.latukha.com" title="Latukha: Good day my friend!" class="md-nav__button md-logo" aria-label="Latukha: Good day my friend!">
      
  <img src="../assets/images/favicon-min.png" alt="logo">

    </a>
    Latukha: Good day my friend!
  </label>
  
    <div class="md-nav__source">
      
<a href="https://github.com/Anton-Latukha/" title="Go to repository" class="md-source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path d="M439.55 236.05L244 40.45a28.87 28.87 0 00-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 01-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 000 40.81l195.61 195.6a28.86 28.86 0 0040.8 0l194.69-194.69a28.86 28.86 0 000-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    Profile
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      


  <li class="md-nav__item">
    <a href=".." class="md-nav__link">
      Home
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../bio/" class="md-nav__link">
      Biography
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../about/" class="md-nav__link">
      About
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../haskell-notes.html" class="md-nav__link">
      Book "Fundamental Haskell"
    </a>
  </li>

    
      
      
      

  


  <li class="md-nav__item md-nav__item--active md-nav__item--nested">
    
    <input class="md-nav__toggle md-toggle" data-md-toggle="nav-5" type="checkbox" id="nav-5" checked>
    <label class="md-nav__link" for="nav-5">
      Articles
      <span class="md-nav__icon md-icon"></span>
    </label>
    <nav class="md-nav" aria-label="Articles" data-md-level="1">
      <label class="md-nav__title" for="nav-5">
        <span class="md-nav__icon md-icon"></span>
        Articles
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../2020-12-08-Haskell-Nixpkgs-integration-test/" class="md-nav__link">
      Haskell Nixpkgs integration test
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../2020-08-08-Use-Linux-file-manager-for-Wine-applications/" class="md-nav__link">
      Use Linux file manager for Wine applications
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../2019-08-02-NixOS-HIE-Emacs/" class="md-nav__link">
      Integrating NixOS/Nix, Haskell IDE Engine, Emacs
    </a>
  </li>

        
          
          
          

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-nav__toggle md-toggle" data-md-toggle="toc" type="checkbox" id="__toc">
    
      
    
    
      <label class="md-nav__link md-nav__link--active" for="__toc">
        Restore of deleted LVM (Advanced)
        <span class="md-nav__icon md-icon"></span>
      </label>
    
    <a href="./" class="md-nav__link md-nav__link--active">
      Restore of deleted LVM (Advanced)
    </a>
    
      
<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#how-to-do-boot-sectot-backups" class="md-nav__link">
    How to do boot-sectot backups
  </a>
  
    <nav class="md-nav" aria-label="How to do boot-sectot backups">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#gpt-case" class="md-nav__link">
    GPT case
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#mbr-case" class="md-nav__link">
    MBR case
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#lvm" class="md-nav__link">
    LVM
  </a>
  
    <nav class="md-nav" aria-label="LVM">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#more-info-on-lvm" class="md-nav__link">
    More info on LVM
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#explaining-the-idea" class="md-nav__link">
    Explaining the idea
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#process-of-restoring" class="md-nav__link">
    Process of restoring
  </a>
  
    <nav class="md-nav" aria-label="Process of restoring">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#backup-full-device" class="md-nav__link">
    Backup full device
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#choose-right-partition-table" class="md-nav__link">
    Choose right partition table
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#analyze-of-the-system-long-operation" class="md-nav__link">
    Analyze of the system (long operation)
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#restoring-lvm-partition-with-testdisc" class="md-nav__link">
    Restoring LVM partition with TestDisc
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#rebooting-system" class="md-nav__link">
    Rebooting system
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#checking-state" class="md-nav__link">
    Checking state
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#restoring-from-backup" class="md-nav__link">
    Restoring from backup
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#next-reboot" class="md-nav__link">
    Next reboot
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#optional-make-partition-bootable" class="md-nav__link">
    (optional) Make partition bootable
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#mounting-everything-on-working-system-preparing-for-chroot" class="md-nav__link">
    Mounting everything on working system (preparing for chroot)
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#chrooting" class="md-nav__link">
    Chrooting
  </a>
  
    <nav class="md-nav" aria-label="Chrooting">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#setup-the-bootloader" class="md-nav__link">
    Setup the bootloader
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#congratulations" class="md-nav__link">
    Congratulations!
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
    
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../2017-04-14-How-to-setup-proxy-to-listen-Spotify/" class="md-nav__link">
      How to setup proxy to listen Spotify
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../2017-04-12-SaltStack-Formulas-install/" class="md-nav__link">
      SaltStack formulas
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#how-to-do-boot-sectot-backups" class="md-nav__link">
    How to do boot-sectot backups
  </a>
  
    <nav class="md-nav" aria-label="How to do boot-sectot backups">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#gpt-case" class="md-nav__link">
    GPT case
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#mbr-case" class="md-nav__link">
    MBR case
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#lvm" class="md-nav__link">
    LVM
  </a>
  
    <nav class="md-nav" aria-label="LVM">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#more-info-on-lvm" class="md-nav__link">
    More info on LVM
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#explaining-the-idea" class="md-nav__link">
    Explaining the idea
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#process-of-restoring" class="md-nav__link">
    Process of restoring
  </a>
  
    <nav class="md-nav" aria-label="Process of restoring">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#backup-full-device" class="md-nav__link">
    Backup full device
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#choose-right-partition-table" class="md-nav__link">
    Choose right partition table
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#analyze-of-the-system-long-operation" class="md-nav__link">
    Analyze of the system (long operation)
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#restoring-lvm-partition-with-testdisc" class="md-nav__link">
    Restoring LVM partition with TestDisc
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#rebooting-system" class="md-nav__link">
    Rebooting system
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#checking-state" class="md-nav__link">
    Checking state
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#restoring-from-backup" class="md-nav__link">
    Restoring from backup
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#next-reboot" class="md-nav__link">
    Next reboot
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#optional-make-partition-bootable" class="md-nav__link">
    (optional) Make partition bootable
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#mounting-everything-on-working-system-preparing-for-chroot" class="md-nav__link">
    Mounting everything on working system (preparing for chroot)
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#chrooting" class="md-nav__link">
    Chrooting
  </a>
  
    <nav class="md-nav" aria-label="Chrooting">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#setup-the-bootloader" class="md-nav__link">
    Setup the bootloader
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#congratulations" class="md-nav__link">
    Congratulations!
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                  <a href="https://github.com/mkdocs-blog/tree/master/docs/2017-05-04-Restore-of-deleted-LVM-(Advanced).md" title="Edit this page" class="md-content__button md-icon">
                    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20.71 7.04c.39-.39.39-1.04 0-1.41l-2.34-2.34c-.37-.39-1.02-.39-1.41 0l-1.84 1.83 3.75 3.75M3 17.25V21h3.75L17.81 9.93l-3.75-3.75L3 17.25z"/></svg>
                  </a>
                
                
                <h1 id="restore-deleted-lvm-advanced">Restore deleted LVM (Advanced)<a class="headerlink" href="#restore-deleted-lvm-advanced" title="Permanent link">&para;</a></h1>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Case of partition filesystem restore is much-much more trivial. It filesystem got corrupted - refer guides on that topic and use <strong>"TestDisc"</strong>.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Intro</p>
<p>On the whole Internet until this post was no information on how to restore LVM, when no backup was present. <br/>
1. Do backups of the whole drive metadata. <br/>
2. On multiple drives - you would do <a href="#analyze-of-the-system-long-operation">Analyze</a> and <a href="#restoring-lvm-partition-with-testdisc">Restore</a> for all drives involved. <br/></p>
</div>
<p>So one way or another. Boot-sector and partition table are deleted from the drive.
If only that first sectors was erased, it is great, we can work hard and restore the LVM.</p>
<p>If happened the classic in sence of:</p>
<div class="highlight"><pre><span></span><code>dd <span class="k">if</span><span class="o">=</span>/dev/zero <span class="nv">of</span><span class="o">=</span>/dev/<span class="o">{</span>h,p,s<span class="o">}</span>d<span class="o">[</span>a..x<span class="o">]</span> <span class="nv">bs</span><span class="o">=</span><span class="m">512</span> <span class="nv">count</span><span class="o">=</span><span class="m">1</span>   <span class="c1"># Do not paste this to root prompt!</span>
<span class="c1"># Like:</span>
<span class="c1"># dd if=/dev/zero of=/dev/sda bs=512 count=1              # Do not paste this to root prompt!</span>
</code></pre></div>
<h2 id="how-to-do-boot-sectot-backups">How to do boot-sectot backups<a class="headerlink" href="#how-to-do-boot-sectot-backups" title="Permanent link">&para;</a></h2>
<h3 id="gpt-case">GPT case<a class="headerlink" href="#gpt-case" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code>sgdisk -b<span class="o">=</span>/path/to/backup/drive-sgdisk.bak /path/to/device
</code></pre></div>
<h3 id="mbr-case">MBR case<a class="headerlink" href="#mbr-case" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code>dd <span class="k">if</span><span class="o">=</span>/dev/<span class="o">[</span>hps<span class="o">]</span>d<span class="o">[</span>a-x<span class="o">]</span> <span class="nv">of</span><span class="o">=</span>/backup/<span class="o">[</span>hps<span class="o">]</span>d<span class="o">[</span>a-x<span class="o">]</span> <span class="nv">bs</span><span class="o">=</span><span class="m">512</span> <span class="nv">count</span><span class="o">=</span><span class="m">1</span>
<span class="c1"># Like:</span>
<span class="c1"># dd if=&#39;/dev/sda of=/backup/&#39;`date --iso`&#39;. sda&#39; bs=512 count=1</span>
</code></pre></div>
<h2 id="lvm">LVM<a class="headerlink" href="#lvm" title="Permanent link">&para;</a></h2>
<p><img alt="LVM Logo" src="../assets/images/lvm_logo.svg" /></p>
<p>LVM complicates the task of recovery, because it is basically a dynamically shifting layer between physical drives partitions and filesystems.</p>
<p>Delete the LVM info - filesystem with data basically locked in a chaos claster you can not penetrate.</p>
<p>There is small info on Internet on how to resurrect your true HDD/SDD LVM friend(s) alive - but check that info anyway also.</p>
<p>Here is the black magic.</p>
<ol>
<li>If you understand LVM in depth. LVM dynamically allocates physical space pieces (Physical extent (PE)).<blockquote>
<p><strong>Physical extent (PE)</strong>
<p style="margin-left: 40px">The smallest size in the physical volume that can be assigned to a logical volume (default 4MiB))</p>
This is one of main facts here.</p>
</blockquote>
</li>
<li>Second fact - like most disc solutions - LVM does not shrink by itself.
We can do that process, if we want. But LVM, by itself, only expands.</li>
<li>Third fact - LVM does not move Physical extents (PE) around, they are statically placed. They allocated from free pool, given to Logical volume (LV), written in it info and that is it.</li>
</ol>
<p>But now you see. LVM is a array of Physical extent (PE), and they was allocated and information stored on them is a complete chaos to us and to tools of recovery (they does not support LVM). That is why it seems impossible to resurrect for most people. But with dedication, way is described here.</p>
<h3 id="more-info-on-lvm">More info on LVM<a class="headerlink" href="#more-info-on-lvm" title="Permanent link">&para;</a></h3>
<p>LVM maps Physical volumes (PV), to Volume groups (VG).</p>
<blockquote>
<p><strong>Physical volume (PV)</strong>
<p style="margin-left: 40px"> Partition on hard disk (or even the disk itself or loopback file) on which you can have volume groups. It has a special header and is divided into physical extents. Think of physical volumes as big building blocks used to build your hard drive. </p></p>
</blockquote>
<p><br/></p>
<blockquote>
<p><strong>Volume group (VG)</strong>
<p style="margin-left: 40px">  Group of physical volumes used as a storage volume (as one disk). They contain logical volumes. Think of volume groups as hard drives. </p></p>
</blockquote>
<p>On Volume group (VG) you can describe a Logical volume (LV).</p>
<blockquote>
<p><strong>Logical volume (LV)</strong>
<p style="margin-left: 40px"> A "virtual/logical partition" that resides in a volume group and is composed of physical extents. Think of logical volumes as normal partitions. </p></p>
</blockquote>
<p>And when Logical volume is going to need to expand its physical space, it does this by getting Physical extent (PE) and mapping it to Logical extent (LE) units, that then LVM includes to Logical volume (LV). It can expand until reaching quota, or free Volume group space available.</p>
<p>Logical extent (LE) units are additional abstraction for mapping LVM RAID PEs or PEs from different drives to single Logical volume.</p>
<p><img alt="LVM structure" src="../assets/images/lvm_struct.svg" /></p>
<h2 id="explaining-the-idea">Explaining the idea<a class="headerlink" href="#explaining-the-idea" title="Permanent link">&para;</a></h2>
<p>Besides corner stones described in <a href="#lvm">LVM</a>, next piece also plays as important part.</p>
<p>Not so known fact, LVM does a backups of it's work information.
In <code>/etc/lvm/backup</code> it stores last backup. In <code>/etc/lvm/archive</code> lays a history of previous backup versions.</p>
<p>But it is a backup inside the filesystem we trying to restore.</p>
<p>Here comes a dirty magic I was talking about.</p>
<p>If only we could revive LVM to any metadata state (even non-consistent), than almost certainly we can expect to get the hold of that <code>/etc/lvm/backup</code>. And it going to shine a lite on us.</p>
<p>TestDisc can find LVM partition remains, but TestDisc doesn't support work with LVM. It only can say: it looks like some version of LVM table. So TestDisc can't somehow find for us, what version of LVM structure it restores (old or last one), and how consistent that LVM data is.</p>
<p>So idea is. To revive the largest LVM TestDisc can find (probably the latest one, because LVM only expands most of the time and LVM PE data is static), and then <code>chroot</code> to that somewhat alive filesystem from working system and restore <code>/etc/lvm/backup</code>.</p>
<h2 id="process-of-restoring">Process of restoring<a class="headerlink" href="#process-of-restoring" title="Permanent link">&para;</a></h2>
<div class="admonition tip">
<p class="admonition-title">Tip</p>
<p>For LVM on multiple drives - you must do <a href="#analyze-of-the-system-long-operation">Analyze</a> and <a href="#restoring-lvm-partition-with-testdisc">Restore</a> for all drives involved. After that next step - recovery - is going to be successful.</p>
</div>
<ul>
<li>Connect the drive to working system or boot from Live image <strong>that is compatible with distribution that you restore.</strong></li>
</ul>
<div class="admonition example">
<p class="admonition-title">Example</p>
<p>As I used Arch Linux on that machine, I used Arch based Antergos Live image. DD-t ISO on a flash drive. Antergos image has X11, Desktop Environment and Gparted prettiness.</p>
</div>
<ul>
<li>Install (update) <code>lvm2</code> and <code>testdisk</code>.
LVM2 as you guess provide LVM support.
TestDisk is magical but not intuitive tool.</li>
</ul>
<h3 id="backup-full-device">Backup full device<a class="headerlink" href="#backup-full-device" title="Permanent link">&para;</a></h3>
<p>Backup at least what is on the drive:
<div class="highlight"><pre><span></span><code>ddrescue -v -f -n /path/to/drive /backup/path /backup/path/rescue.log
</code></pre></div></p>
<p>Because the process is somewhat nontrivial, long and uses a hack in it.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p><code>ddrescue</code> output <a href="https://superuser.com/questions/630951/why-is-it-impossible-to-compress-on-the-fly-images-by-ddrescue">can't be archived on the fly</a>. If you need compression - use filesystem level compression on the backup media. </p>
</div>
<h3 id="choose-right-partition-table">Choose right partition table<a class="headerlink" href="#choose-right-partition-table" title="Permanent link">&para;</a></h3>
<p>Choose here right type of the partition. It is up to your research. Probably you have one of: <code>[EFI GPT], [Mac ], [Intel ]</code>.
<div class="highlight"><pre><span></span><code>TestDisk 7.0, Data Recovery Utility, April 2015
Christophe GRENIER &lt;grenier@cgsecurity.org&gt;
http://www.cgsecurity.org


Disk /dev/sda - 1000 GB / 931 GiB - Hitachi HDS721010CLA330

Please select the partition table type, press Enter when done.
[Intel ] Intel/PC partition
&gt;[EFI GPT] EFI GPT partition map (Mac i386, some x86_64...)
[Humax ] Humax partition table
[Mac ] Apple partition map
[None ] Non partitioned media
[Sun ] Sun Solaris partition
[XBox ] XBox partition
[Return ] Return to disk selection
</code></pre></div></p>
<p>Hint: Intel partition table type has been detected.
Note: Do NOT select 'None' for media with only a single partition. It's very
rare for a disk to be 'Non-partitioned'.</p>
<h3 id="analyze-of-the-system-long-operation">Analyze of the system (long operation)<a class="headerlink" href="#analyze-of-the-system-long-operation" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code>TestDisk 7.0, Data Recovery Utility, April 2015
Christophe GRENIER &lt;grenier@cgsecurity.org&gt;
http://www.cgsecurity.org


Disk /dev/sda - 1000 GB / 931 GiB - Hitachi HDS721010CLA330
 CHS 121601 255 63 - sector size=512

&gt;[ Analyse ] Analyse current partition structure and search for lost partitions
[ Advanced ] Filesystem Utils
[ Geometry ] Change disk geometry
[ Options ] Modify options
[ MBR Code ] Write TestDisk MBR code to first sector
[ Delete ] Delete all data in the partition table
[ Quit ] Return to disk selection
</code></pre></div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Correct disk geometry is required for a successful recovery. 'Analyse' process may give some warnings if it thinks the logical geometry is mismatched.</p>
</div>
<div class="highlight"><pre><span></span><code>TestDisk 7.0, Data Recovery Utility, April 2015
Christophe GRENIER &lt;grenier@cgsecurity.org&gt;
http://www.cgsecurity.org

Disk /dev/sda - 1000 GB / 931 GiB - CHS 121601 255 63
 Partition Start End Size in sectors
&gt;P Linux LVM 0 32 33 121601 90 25 1953523712
</code></pre></div>
<p><br/></p>
<div class="highlight"><pre><span></span><code>TestDisk 7.0, Data Recovery Utility, April 2015
Christophe GRENIER &lt;grenier@cgsecurity.org&gt;
http://www.cgsecurity.org

Disk /dev/sda - 1000 GB / 931 GiB - CHS 121601 255 63

 Partition Start End Size in sectors

1 P Linux LVM 0 32 33 121601 90 25 1953523712
</code></pre></div>
<p><br/></p>
<div class="highlight"><pre><span></span><code>TestDisk 7.0, Data Recovery Utility, April 2015
Christophe GRENIER &lt;grenier@cgsecurity.org&gt;
http://www.cgsecurity.org

Disk /dev/sda - 1000 GB / 931 GiB - CHS 121601 255 63
Analyse cylinder 553/121600: 00%


 Linux LVM 0 32 33 121601 80 63 1953523120
 Linux 0 65 2 13 0 51 204800
 Linux 0 64 63 13 0 49 204800
 Linux 0 64 63 13 0 49 204800
 Linux 0 64 63 13 0 49 204800
 Linux 0 64 63 13 0 49 204800
 Linux 0 64 63 13 0 49 204800
 Linux 13 0 52 3276 138 62 52428800






 Stop  
</code></pre></div>
<h3 id="restoring-lvm-partition-with-testdisc">Restoring LVM partition with TestDisc<a class="headerlink" href="#restoring-lvm-partition-with-testdisc" title="Permanent link">&para;</a></h3>
<p>After that scan TestDisc review several partitions to restore. One of which is LVM. And it says drive is to small (1T&lt;1.3T or something like that) to reincarnate all that partitions. So you restore the LVM partition (the biggest).</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>At this stage partition and filesystem can be in inconsistent state. Minimize writing to system and proceed further. Restore from backup is going to get us consistent filesystem.</p>
</div>
<h3 id="rebooting-system">Rebooting system<a class="headerlink" href="#rebooting-system" title="Permanent link">&para;</a></h3>
<p>To refresh drive boot-partition information - reboot after restoring.</p>
<h3 id="checking-state">Checking state<a class="headerlink" href="#checking-state" title="Permanent link">&para;</a></h3>
<p>After reboot while doing:
<div class="highlight"><pre><span></span><code>[antergos@ant-16.9 etc]$ lsblk
NAME MAJ:MIN RM SIZE RO TYPE MOUNTPOINT
sda 8:0 0 931.5G 0 disk 
sda1 8:1 0 931.5G 0 part 
 archvg-boot 254:0 0 100M 0 lvm  
 archvg-archroot 254:1 0 25G 0 lvm /mnt/etc
 archvg-archvar 254:2 0 15G 0 lvm /run/media/antergos/244907d8-7c9f-
 archvg-swap 254:3 0 8G 0 lvm  
 archvg-vault 254:4 0 800G 0 lvm  
 archvg-crypt 254:5 0 1G 0 lvm  
 archvg-archhome 254:6 0 20G 0 lvm /run/media/antergos/e2d59443-1e66-
</code></pre></div></p>
<p>You began to see:
<div class="highlight"><pre><span></span><code>[antergos@ant-16.9 etc]$ sudo vgscan
 Reading volume groups from cache.
 Found volume group &quot;archvg&quot; using metadata type lvm2
</code></pre></div></p>
<h3 id="restoring-from-backup">Restoring from backup<a class="headerlink" href="#restoring-from-backup" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code>sudo -s

<span class="c1"># Change volume group attribute to activated</span>
vgchange -ay archvg

mkdir /mnt/root/

<span class="c1"># We need to mount only partition that has backup</span>
mount /dev/disk/by-id/archvg-root /mnt/root/

<span class="c1"># Locate/print block device attributes</span>
blkid /dev/sda1
<span class="c1"># /dev/sda1: UUID=&quot;7SFaGJ-LKnf-mlx7-m8dY-1bg4-epWM-09y8vR&quot; TYPE=&quot;LVM2_member&quot;</span>

<span class="c1"># Investigate backup. Compare with information above</span>
cat /mnt/root/etc/lvm/backup/archvg

<span class="c1"># Restore volume group configuration</span>
vgcfgrestore -f /mnt/root/etc/lvm/backup/archvg archvg
<span class="c1">#Metadata Restored</span>
</code></pre></div>
<h3 id="next-reboot">Next reboot<a class="headerlink" href="#next-reboot" title="Permanent link">&para;</a></h3>
<p>Reboot.</p>
<p>After that, if you try to boot to recovered system, - you can get error:</p>
<blockquote>
<p>1234F:</p>
</blockquote>
<p>Because no bootloader was configured. Now we need boot from Live image once more.</p>
<h3 id="optional-make-partition-bootable">(optional) Make partition bootable<a class="headerlink" href="#optional-make-partition-bootable" title="Permanent link">&para;</a></h3>
<p>If you was booting from LVM.</p>
<p>Mark partition bootable (that flag was in old boot-sector, as you know old-one went away).
<code>sudo gparted</code>.
Right click on partition. Flags. "boot".</p>
<h3 id="mounting-everything-on-working-system-preparing-for-chroot">Mounting everything on working system (preparing for chroot)<a class="headerlink" href="#mounting-everything-on-working-system-preparing-for-chroot" title="Permanent link">&para;</a></h3>
<p>Now you need by yourself mount all LVM volumes to single tree in /mnt/root, exactly how it was on that system.
Because your LVM config is unique, as also mine, I can't give you literal instructions.</p>
<div class="admonition example">
<p class="admonition-title">Example</p>
<p>I going to mount:
<div class="highlight"><pre><span></span><code>archvg-archroot /mnt/root/
archvg-boot     /mnt/root/boot
archvg-archvar  /mnt/root/var
archvg-archhome /mnt/root/home
archvg-vault    /mnt/root/mnt/vault
archvg-crypt    /mnt/root/mnt/crypt
</code></pre></div></p>
<p>So I did:
<div class="highlight"><pre><span></span><code>sudo -s
mkdir -p /mnt/root/
mount /dev/disk/by-id/dm-name-archvg-archroot /mnt/root/
mkdir -p /mnt/root/boot
mount /dev/disk/by-id/dm-name-archvg-boot /mnt/root/boot
mkdir -p /mnt/root/var
mount /dev/disk/by-id/dm-name-archvg-archvar /mnt/root/var
mkdir -p /mnt/root/home
mount /dev/disk/by-id/dm-name-archvg-archhome /mnt/root/home
mkdir -p /mnt/root/mnt/vault
mount /dev/disk/by-id/dm-name-archvg-vault /mnt/root/mnt/vault
mkdir -p /mnt/root/mnt/crypt
mount /dev/disk/by-id/dm-name-archvg-crypt /mnt/root/mnt/crypt
swapon /dev/disk/by-id/dm-name-archvg-swap
swapon
lsblk <span class="c1"># check everything</span>
</code></pre></div></p>
</div>
<div class="admonition tip">
<p class="admonition-title">Tip</p>
<p>Control what you are mounting where with <code>lsblk</code>. You need do everything right before going <code>chroot</code>.</p>
</div>
<h3 id="chrooting">Chrooting<a class="headerlink" href="#chrooting" title="Permanent link">&para;</a></h3>
<p><a href="https://wiki.archlinux.org/index.php/change_root">Chroot</a> to the system:</p>
<div class="highlight"><pre><span></span><code>arch-chroot /mnt/root /bin/fish
</code></pre></div>
<p>System maps filesystem data to current system.</p>
<h4 id="setup-the-bootloader">Setup the bootloader<a class="headerlink" href="#setup-the-bootloader" title="Permanent link">&para;</a></h4>
<p>On this system <a href="https://wiki.archlinux.org/index.php/GRUB">bootloader</a> was <a href="https://wiki.archlinux.org/index.php/GRUB#Master_Boot_Record_.28MBR.29_specific_instructions">this</a>:</p>
<div class="highlight"><pre><span></span><code>pacman -Sy grub

lsblk

grub-install --target<span class="o">=</span>i386-pc /dev/sda

ls /boot/grub/grub.cfg*

diff /boot/grub/grub.cfg /boot/grub/grub.cfg.pacnew

grub-mkconfig -o /boot/grub/grub.cfg
</code></pre></div>
<h3 id="congratulations">Congratulations!<a class="headerlink" href="#congratulations" title="Permanent link">&para;</a></h3>
<div class="admonition success">
<p class="admonition-title">Success</p>
<p>After this you have fully restored system. So now you can reboot to your long awaited system and everything is going to run smooth.</p>
</div>
                
              
              
                


  <h2 id="__comments">Comments</h2>
  <div id="disqus_thread"></div>
  <script>var disqus_config=function(){this.page.url="https://blog.latukha.com/2017-05-04-Restore-of-deleted-LVM-%28Advanced%29/",this.page.identifier="/2017-05-04-Restore-of-deleted-LVM-%28Advanced%29/"};window.addEventListener("load",function(){var e=document,i=e.createElement("script");i.src="//blog-latukha-com.disqus.com/embed.js",i.setAttribute("data-timestamp",+new Date),(e.head||e.body).appendChild(i)})</script>

              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid" aria-label="Footer">
        
          <a href="../2019-08-02-NixOS-HIE-Emacs/" class="md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-footer-nav__button md-icon">
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"/></svg>
            </div>
            <div class="md-footer-nav__title">
              <div class="md-ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Integrating NixOS/Nix, Haskell IDE Engine, Emacs
              </div>
            </div>
          </a>
        
        
          <a href="../2017-04-14-How-to-setup-proxy-to-listen-Spotify/" class="md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-footer-nav__title">
              <div class="md-ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                How to setup proxy to listen Spotify
              </div>
            </div>
            <div class="md-footer-nav__button md-icon">
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4z"/></svg>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            2016-2020 Anton Latukha, Creative Commons ShareAlike
          </div>
        
        Made with
        <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
          Material for MkDocs
        </a>
      </div>
      
  <div class="md-footer-social">
    
      
      
        
        
      
      <a href="https://github.com/Anton-Latukha" target="_blank" rel="noopener" title="github.com" class="md-footer-social__link">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 16 16"><path fill-rule="evenodd" d="M8 0C3.58 0 0 3.58 0 8c0 3.54 2.29 6.53 5.47 7.59.4.07.55-.17.55-.38 0-.19-.01-.82-.01-1.49-2.01.37-2.53-.49-2.69-.94-.09-.23-.48-.94-.82-1.13-.28-.15-.68-.52-.01-.53.63-.01 1.08.58 1.23.82.72 1.21 1.87.87 2.33.66.07-.52.28-.87.51-1.07-1.78-.2-3.64-.89-3.64-3.95 0-.87.31-1.59.82-2.15-.08-.2-.36-1.02.08-2.12 0 0 .67-.21 2.2.82.64-.18 1.32-.27 2-.27.68 0 1.36.09 2 .27 1.53-1.04 2.2-.82 2.2-.82.44 1.1.16 1.92.08 2.12.51.56.82 1.27.82 2.15 0 3.07-1.87 3.75-3.65 3.95.29.25.54.73.54 1.48 0 1.07-.01 1.93-.01 2.2 0 .21.15.46.55.38A8.013 8.013 0 0016 8c0-4.42-3.58-8-8-8z"/></svg>
      </a>
    
      
      
        
        
      
      <a href="https://gitlab.com/Anton.Latukha" target="_blank" rel="noopener" title="gitlab.com" class="md-footer-social__link">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path d="M105.2 24.9c-3.1-8.9-15.7-8.9-18.9 0L29.8 199.7h132c-.1 0-56.6-174.8-56.6-174.8zM.9 287.7c-2.6 8 .3 16.9 7.1 22l247.9 184-226.2-294zm160.8-88l94.3 294 94.3-294zm349.4 88l-28.8-88-226.3 294 247.9-184c6.9-5.1 9.7-14 7.2-22zM425.7 24.9c-3.1-8.9-15.7-8.9-18.9 0l-56.6 174.8h132z"/></svg>
      </a>
    
      
      
        
        
      
      <a href="https://twitter.com/piroxiline" target="_blank" rel="noopener" title="twitter.com" class="md-footer-social__link">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path d="M459.37 151.716c.325 4.548.325 9.097.325 13.645 0 138.72-105.583 298.558-298.558 298.558-59.452 0-114.68-17.219-161.137-47.106 8.447.974 16.568 1.299 25.34 1.299 49.055 0 94.213-16.568 130.274-44.832-46.132-.975-84.792-31.188-98.112-72.772 6.498.974 12.995 1.624 19.818 1.624 9.421 0 18.843-1.3 27.614-3.573-48.081-9.747-84.143-51.98-84.143-102.985v-1.299c13.969 7.797 30.214 12.67 47.431 13.319-28.264-18.843-46.781-51.005-46.781-87.391 0-19.492 5.197-37.36 14.294-52.954 51.655 63.675 129.3 105.258 216.365 109.807-1.624-7.797-2.599-15.918-2.599-24.04 0-57.828 46.782-104.934 104.934-104.934 30.213 0 57.502 12.67 76.67 33.137 23.715-4.548 46.456-13.32 66.599-25.34-7.798 24.366-24.366 44.833-46.132 57.827 21.117-2.273 41.584-8.122 60.426-16.243-14.292 20.791-32.161 39.308-52.628 54.253z"/></svg>
      </a>
    
      
      
        
        
      
      <a href="https://linkedin.com/in/anton-latukha-2a286690" target="_blank" rel="noopener" title="linkedin.com" class="md-footer-social__link">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path d="M416 32H31.9C14.3 32 0 46.5 0 64.3v383.4C0 465.5 14.3 480 31.9 480H416c17.6 0 32-14.5 32-32.3V64.3c0-17.8-14.4-32.3-32-32.3zM135.4 416H69V202.2h66.5V416zm-33.2-243c-21.3 0-38.5-17.3-38.5-38.5S80.9 96 102.2 96c21.2 0 38.5 17.3 38.5 38.5 0 21.3-17.2 38.5-38.5 38.5zm282.1 243h-66.4V312c0-24.8-.5-56.7-34.5-56.7-34.6 0-39.9 27-39.9 54.9V416h-66.4V202.2h63.7v29.2h.9c8.9-16.8 30.6-34.5 62.9-34.5 67.2 0 79.7 44.3 79.7 101.9V416z"/></svg>
      </a>
    
      
      
        
        
      
      <a href="https://github.com/Anton-Latukha/Anton-Latukha.github.io/raw/master/assets/docs/AntonLatukhaCV.pdf" target="_blank" rel="noopener" title="github.com" class="md-footer-social__link">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path fill-rule="evenodd" d="M6.736 4C4.657 4 2.5 5.88 2.5 8.514c0 3.107 2.324 5.96 4.861 8.12a29.66 29.66 0 004.566 3.175l.073.041.073-.04c.271-.153.661-.38 1.13-.674.94-.588 2.19-1.441 3.436-2.502 2.537-2.16 4.861-5.013 4.861-8.12C21.5 5.88 19.343 4 17.264 4c-2.106 0-3.801 1.389-4.553 3.643a.75.75 0 01-1.422 0C10.537 5.389 8.841 4 6.736 4zM12 20.703l.343.667a.75.75 0 01-.686 0l.343-.667zM1 8.513C1 5.053 3.829 2.5 6.736 2.5 9.03 2.5 10.881 3.726 12 5.605 13.12 3.726 14.97 2.5 17.264 2.5 20.17 2.5 23 5.052 23 8.514c0 3.818-2.801 7.06-5.389 9.262a31.146 31.146 0 01-5.233 3.576l-.025.013-.007.003-.002.001-.344-.666-.343.667-.003-.002-.007-.003-.025-.013A29.308 29.308 0 0110 20.408a31.147 31.147 0 01-3.611-2.632C3.8 15.573 1 12.332 1 8.514z"/></svg>
      </a>
    
      
      
        
        
      
      <a href="https://github.com/Anton-Latukha/Anton-Latukha.github.io/raw/master/assets/docs/AntonLatukhaCV.pdf" target="_blank" rel="noopener" title="github.com" class="md-footer-social__link">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M4.97 11.03a.75.75 0 111.06-1.06L11 14.94V2.75a.75.75 0 011.5 0v12.19l4.97-4.97a.75.75 0 111.06 1.06l-6.25 6.25a.75.75 0 01-1.06 0l-6.25-6.25zm-.22 9.47a.75.75 0 000 1.5h14.5a.75.75 0 000-1.5H4.75z"/></svg>
      </a>
    
      
      
        
        
      
      <a href="https://wiki.archlinux.org/index.php/Special:Contributions/Anton_Latukha" target="_blank" rel="noopener" title="wiki.archlinux.org" class="md-footer-social__link">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path d="M220.8 123.3c1 .5 1.8 1.7 3 1.7 1.1 0 2.8-.4 2.9-1.5.2-1.4-1.9-2.3-3.2-2.9-1.7-.7-3.9-1-5.5-.1-.4.2-.8.7-.6 1.1.3 1.3 2.3 1.1 3.4 1.7zm-21.9 1.7c1.2 0 2-1.2 3-1.7 1.1-.6 3.1-.4 3.5-1.6.2-.4-.2-.9-.6-1.1-1.6-.9-3.8-.6-5.5.1-1.3.6-3.4 1.5-3.2 2.9.1 1 1.8 1.5 2.8 1.4zM420 403.8c-3.6-4-5.3-11.6-7.2-19.7-1.8-8.1-3.9-16.8-10.5-22.4-1.3-1.1-2.6-2.1-4-2.9-1.3-.8-2.7-1.5-4.1-2 9.2-27.3 5.6-54.5-3.7-79.1-11.4-30.1-31.3-56.4-46.5-74.4-17.1-21.5-33.7-41.9-33.4-72C311.1 85.4 315.7.1 234.8 0 132.4-.2 158 103.4 156.9 135.2c-1.7 23.4-6.4 41.8-22.5 64.7-18.9 22.5-45.5 58.8-58.1 96.7-6 17.9-8.8 36.1-6.2 53.3-6.5 5.8-11.4 14.7-16.6 20.2-4.2 4.3-10.3 5.9-17 8.3s-14 6-18.5 14.5c-2.1 3.9-2.8 8.1-2.8 12.4 0 3.9.6 7.9 1.2 11.8 1.2 8.1 2.5 15.7.8 20.8-5.2 14.4-5.9 24.4-2.2 31.7 3.8 7.3 11.4 10.5 20.1 12.3 17.3 3.6 40.8 2.7 59.3 12.5 19.8 10.4 39.9 14.1 55.9 10.4 11.6-2.6 21.1-9.6 25.9-20.2 12.5-.1 26.3-5.4 48.3-6.6 14.9-1.2 33.6 5.3 55.1 4.1.6 2.3 1.4 4.6 2.5 6.7v.1c8.3 16.7 23.8 24.3 40.3 23 16.6-1.3 34.1-11 48.3-27.9 13.6-16.4 36-23.2 50.9-32.2 7.4-4.5 13.4-10.1 13.9-18.3.4-8.2-4.4-17.3-15.5-29.7zM223.7 87.3c9.8-22.2 34.2-21.8 44-.4 6.5 14.2 3.6 30.9-4.3 40.4-1.6-.8-5.9-2.6-12.6-4.9 1.1-1.2 3.1-2.7 3.9-4.6 4.8-11.8-.2-27-9.1-27.3-7.3-.5-13.9 10.8-11.8 23-4.1-2-9.4-3.5-13-4.4-1-6.9-.3-14.6 2.9-21.8zM183 75.8c10.1 0 20.8 14.2 19.1 33.5-3.5 1-7.1 2.5-10.2 4.6 1.2-8.9-3.3-20.1-9.6-19.6-8.4.7-9.8 21.2-1.8 28.1 1 .8 1.9-.2-5.9 5.5-15.6-14.6-10.5-52.1 8.4-52.1zm-13.6 60.7c6.2-4.6 13.6-10 14.1-10.5 4.7-4.4 13.5-14.2 27.9-14.2 7.1 0 15.6 2.3 25.9 8.9 6.3 4.1 11.3 4.4 22.6 9.3 8.4 3.5 13.7 9.7 10.5 18.2-2.6 7.1-11 14.4-22.7 18.1-11.1 3.6-19.8 16-38.2 14.9-3.9-.2-7-1-9.6-2.1-8-3.5-12.2-10.4-20-15-8.6-4.8-13.2-10.4-14.7-15.3-1.4-4.9 0-9 4.2-12.3zm3.3 334c-2.7 35.1-43.9 34.4-75.3 18-29.9-15.8-68.6-6.5-76.5-21.9-2.4-4.7-2.4-12.7 2.6-26.4v-.2c2.4-7.6.6-16-.6-23.9-1.2-7.8-1.8-15 .9-20 3.5-6.7 8.5-9.1 14.8-11.3 10.3-3.7 11.8-3.4 19.6-9.9 5.5-5.7 9.5-12.9 14.3-18 5.1-5.5 10-8.1 17.7-6.9 8.1 1.2 15.1 6.8 21.9 16l19.6 35.6c9.5 19.9 43.1 48.4 41 68.9zm-1.4-25.9c-4.1-6.6-9.6-13.6-14.4-19.6 7.1 0 14.2-2.2 16.7-8.9 2.3-6.2 0-14.9-7.4-24.9-13.5-18.2-38.3-32.5-38.3-32.5-13.5-8.4-21.1-18.7-24.6-29.9s-3-23.3-.3-35.2c5.2-22.9 18.6-45.2 27.2-59.2 2.3-1.7.8 3.2-8.7 20.8-8.5 16.1-24.4 53.3-2.6 82.4.6-20.7 5.5-41.8 13.8-61.5 12-27.4 37.3-74.9 39.3-112.7 1.1.8 4.6 3.2 6.2 4.1 4.6 2.7 8.1 6.7 12.6 10.3 12.4 10 28.5 9.2 42.4 1.2 6.2-3.5 11.2-7.5 15.9-9 9.9-3.1 17.8-8.6 22.3-15 7.7 30.4 25.7 74.3 37.2 95.7 6.1 11.4 18.3 35.5 23.6 64.6 3.3-.1 7 .4 10.9 1.4 13.8-35.7-11.7-74.2-23.3-84.9-4.7-4.6-4.9-6.6-2.6-6.5 12.6 11.2 29.2 33.7 35.2 59 2.8 11.6 3.3 23.7.4 35.7 16.4 6.8 35.9 17.9 30.7 34.8-2.2-.1-3.2 0-4.2 0 3.2-10.1-3.9-17.6-22.8-26.1-19.6-8.6-36-8.6-38.3 12.5-12.1 4.2-18.3 14.7-21.4 27.3-2.8 11.2-3.6 24.7-4.4 39.9-.5 7.7-3.6 18-6.8 29-32.1 22.9-76.7 32.9-114.3 7.2zm257.4-11.5c-.9 16.8-41.2 19.9-63.2 46.5-13.2 15.7-29.4 24.4-43.6 25.5s-26.5-4.8-33.7-19.3c-4.7-11.1-2.4-23.1 1.1-36.3 3.7-14.2 9.2-28.8 9.9-40.6.8-15.2 1.7-28.5 4.2-38.7 2.6-10.3 6.6-17.2 13.7-21.1.3-.2.7-.3 1-.5.8 13.2 7.3 26.6 18.8 29.5 12.6 3.3 30.7-7.5 38.4-16.3 9-.3 15.7-.9 22.6 5.1 9.9 8.5 7.1 30.3 17.1 41.6 10.6 11.6 14 19.5 13.7 24.6zM173.3 148.7c2 1.9 4.7 4.5 8 7.1 6.6 5.2 15.8 10.6 27.3 10.6 11.6 0 22.5-5.9 31.8-10.8 4.9-2.6 10.9-7 14.8-10.4s5.9-6.3 3.1-6.6-2.6 2.6-6 5.1c-4.4 3.2-9.7 7.4-13.9 9.8-7.4 4.2-19.5 10.2-29.9 10.2s-18.7-4.8-24.9-9.7c-3.1-2.5-5.7-5-7.7-6.9-1.5-1.4-1.9-4.6-4.3-4.9-1.4-.1-1.8 3.7 1.7 6.5z"/></svg>
      </a>
    
      
      
        
        
      
      <a href="https://wiki.archlinux.org/index.php/Special:Contributions/PiroXiline" target="_blank" rel="noopener" title="wiki.archlinux.org" class="md-footer-social__link">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path d="M220.8 123.3c1 .5 1.8 1.7 3 1.7 1.1 0 2.8-.4 2.9-1.5.2-1.4-1.9-2.3-3.2-2.9-1.7-.7-3.9-1-5.5-.1-.4.2-.8.7-.6 1.1.3 1.3 2.3 1.1 3.4 1.7zm-21.9 1.7c1.2 0 2-1.2 3-1.7 1.1-.6 3.1-.4 3.5-1.6.2-.4-.2-.9-.6-1.1-1.6-.9-3.8-.6-5.5.1-1.3.6-3.4 1.5-3.2 2.9.1 1 1.8 1.5 2.8 1.4zM420 403.8c-3.6-4-5.3-11.6-7.2-19.7-1.8-8.1-3.9-16.8-10.5-22.4-1.3-1.1-2.6-2.1-4-2.9-1.3-.8-2.7-1.5-4.1-2 9.2-27.3 5.6-54.5-3.7-79.1-11.4-30.1-31.3-56.4-46.5-74.4-17.1-21.5-33.7-41.9-33.4-72C311.1 85.4 315.7.1 234.8 0 132.4-.2 158 103.4 156.9 135.2c-1.7 23.4-6.4 41.8-22.5 64.7-18.9 22.5-45.5 58.8-58.1 96.7-6 17.9-8.8 36.1-6.2 53.3-6.5 5.8-11.4 14.7-16.6 20.2-4.2 4.3-10.3 5.9-17 8.3s-14 6-18.5 14.5c-2.1 3.9-2.8 8.1-2.8 12.4 0 3.9.6 7.9 1.2 11.8 1.2 8.1 2.5 15.7.8 20.8-5.2 14.4-5.9 24.4-2.2 31.7 3.8 7.3 11.4 10.5 20.1 12.3 17.3 3.6 40.8 2.7 59.3 12.5 19.8 10.4 39.9 14.1 55.9 10.4 11.6-2.6 21.1-9.6 25.9-20.2 12.5-.1 26.3-5.4 48.3-6.6 14.9-1.2 33.6 5.3 55.1 4.1.6 2.3 1.4 4.6 2.5 6.7v.1c8.3 16.7 23.8 24.3 40.3 23 16.6-1.3 34.1-11 48.3-27.9 13.6-16.4 36-23.2 50.9-32.2 7.4-4.5 13.4-10.1 13.9-18.3.4-8.2-4.4-17.3-15.5-29.7zM223.7 87.3c9.8-22.2 34.2-21.8 44-.4 6.5 14.2 3.6 30.9-4.3 40.4-1.6-.8-5.9-2.6-12.6-4.9 1.1-1.2 3.1-2.7 3.9-4.6 4.8-11.8-.2-27-9.1-27.3-7.3-.5-13.9 10.8-11.8 23-4.1-2-9.4-3.5-13-4.4-1-6.9-.3-14.6 2.9-21.8zM183 75.8c10.1 0 20.8 14.2 19.1 33.5-3.5 1-7.1 2.5-10.2 4.6 1.2-8.9-3.3-20.1-9.6-19.6-8.4.7-9.8 21.2-1.8 28.1 1 .8 1.9-.2-5.9 5.5-15.6-14.6-10.5-52.1 8.4-52.1zm-13.6 60.7c6.2-4.6 13.6-10 14.1-10.5 4.7-4.4 13.5-14.2 27.9-14.2 7.1 0 15.6 2.3 25.9 8.9 6.3 4.1 11.3 4.4 22.6 9.3 8.4 3.5 13.7 9.7 10.5 18.2-2.6 7.1-11 14.4-22.7 18.1-11.1 3.6-19.8 16-38.2 14.9-3.9-.2-7-1-9.6-2.1-8-3.5-12.2-10.4-20-15-8.6-4.8-13.2-10.4-14.7-15.3-1.4-4.9 0-9 4.2-12.3zm3.3 334c-2.7 35.1-43.9 34.4-75.3 18-29.9-15.8-68.6-6.5-76.5-21.9-2.4-4.7-2.4-12.7 2.6-26.4v-.2c2.4-7.6.6-16-.6-23.9-1.2-7.8-1.8-15 .9-20 3.5-6.7 8.5-9.1 14.8-11.3 10.3-3.7 11.8-3.4 19.6-9.9 5.5-5.7 9.5-12.9 14.3-18 5.1-5.5 10-8.1 17.7-6.9 8.1 1.2 15.1 6.8 21.9 16l19.6 35.6c9.5 19.9 43.1 48.4 41 68.9zm-1.4-25.9c-4.1-6.6-9.6-13.6-14.4-19.6 7.1 0 14.2-2.2 16.7-8.9 2.3-6.2 0-14.9-7.4-24.9-13.5-18.2-38.3-32.5-38.3-32.5-13.5-8.4-21.1-18.7-24.6-29.9s-3-23.3-.3-35.2c5.2-22.9 18.6-45.2 27.2-59.2 2.3-1.7.8 3.2-8.7 20.8-8.5 16.1-24.4 53.3-2.6 82.4.6-20.7 5.5-41.8 13.8-61.5 12-27.4 37.3-74.9 39.3-112.7 1.1.8 4.6 3.2 6.2 4.1 4.6 2.7 8.1 6.7 12.6 10.3 12.4 10 28.5 9.2 42.4 1.2 6.2-3.5 11.2-7.5 15.9-9 9.9-3.1 17.8-8.6 22.3-15 7.7 30.4 25.7 74.3 37.2 95.7 6.1 11.4 18.3 35.5 23.6 64.6 3.3-.1 7 .4 10.9 1.4 13.8-35.7-11.7-74.2-23.3-84.9-4.7-4.6-4.9-6.6-2.6-6.5 12.6 11.2 29.2 33.7 35.2 59 2.8 11.6 3.3 23.7.4 35.7 16.4 6.8 35.9 17.9 30.7 34.8-2.2-.1-3.2 0-4.2 0 3.2-10.1-3.9-17.6-22.8-26.1-19.6-8.6-36-8.6-38.3 12.5-12.1 4.2-18.3 14.7-21.4 27.3-2.8 11.2-3.6 24.7-4.4 39.9-.5 7.7-3.6 18-6.8 29-32.1 22.9-76.7 32.9-114.3 7.2zm257.4-11.5c-.9 16.8-41.2 19.9-63.2 46.5-13.2 15.7-29.4 24.4-43.6 25.5s-26.5-4.8-33.7-19.3c-4.7-11.1-2.4-23.1 1.1-36.3 3.7-14.2 9.2-28.8 9.9-40.6.8-15.2 1.7-28.5 4.2-38.7 2.6-10.3 6.6-17.2 13.7-21.1.3-.2.7-.3 1-.5.8 13.2 7.3 26.6 18.8 29.5 12.6 3.3 30.7-7.5 38.4-16.3 9-.3 15.7-.9 22.6 5.1 9.9 8.5 7.1 30.3 17.1 41.6 10.6 11.6 14 19.5 13.7 24.6zM173.3 148.7c2 1.9 4.7 4.5 8 7.1 6.6 5.2 15.8 10.6 27.3 10.6 11.6 0 22.5-5.9 31.8-10.8 4.9-2.6 10.9-7 14.8-10.4s5.9-6.3 3.1-6.6-2.6 2.6-6 5.1c-4.4 3.2-9.7 7.4-13.9 9.8-7.4 4.2-19.5 10.2-29.9 10.2s-18.7-4.8-24.9-9.7c-3.1-2.5-5.7-5-7.7-6.9-1.5-1.4-1.9-4.6-4.3-4.9-1.4-.1-1.8 3.7 1.7 6.5z"/></svg>
      </a>
    
  </div>

    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../assets/javascripts/vendor.0ac82a11.min.js"></script>
      <script src="../assets/javascripts/bundle.f81dfb4d.min.js"></script><script id="__lang" type="application/json">{"clipboard.copy": "Copy to clipboard", "clipboard.copied": "Copied to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.placeholder": "Type to start searching", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.term.missing": "Missing"}</script>
      
      <script>
        app = initialize({
          base: "..",
          features: ['tabs', 'instant'],
          search: Object.assign({
            worker: "../assets/javascripts/worker/search.4ac00218.min.js"
          }, typeof search !== "undefined" && search)
        })
      </script>
      
    
  </body>
</html>